/***************************************************************************************
 * @file     reset_handler.s
 * @version  V1.0
 * @date     18. July 2016
 *
 * @note
 * VORAGO Technologies 
 *
 * @note
 * Copyright (c) 2013-2016 VORAGO Technologies. 
 *
 * @par
 * BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND BY 
 * ALL THE TERMS AND CONDITIONS OF THE VORAGO TECHNOLOGIES END USER LICENSE AGREEMENT. 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. VORAGO TECHNOLOGIES 
 * SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL 
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 ****************************************************************************************/
.syntax unified
.cpu cortex-m0
.fpu softvfp
.thumb
.global g_pfnVectors

.word __ROM_AT      /* End of ROM */ 
.word __DATA_START  /* Start address for data section */ 
.word __DATA_END    /* End address for data section */ 
.word __START_BSS   /* Start address for .bss section */
.word __END_BSS     /* End address for .bss section */
.word __STACK_BASE  /* Stack base */ 

.section .text.Reset_Handler
.weak Reset_Handler
.type Reset_Handler, %function
Reset_Handler:
  movs r1, #0             /* Copy .data section from load memory address(LMA) to virtual memory address(VMA) */
  b LMA_To_VMA_Init
LMA_To_VMA_Copy:
  ldr r3, =__ROM_AT
  ldr r3, [r3, r1]
  str r3, [r0, r1]
  adds r1, r1, #4
LMA_To_VMA_Init:
  ldr r0, = __DATA_START
  ldr r3, = __DATA_END
  adds r2, r0, r1
  cmp r2, r3
  bcc LMA_To_VMA_Copy
  ldr r2, =__START_BSS
  b BSS_Init
BSS_Set_Zero:              /* Initialize .bss section w/ zeros */ 
  movs r3, #0
  str r3, [r2]
  adds r2, r2, #4
BSS_Init:
  ldr r3, = __END_BSS
  cmp r2, r3
  bcc BSS_Set_Zero 
  bl main                 /* Call the application's entry point */
  bx lr
.size Reset_Handler, .-Reset_Handler
 
 
 