/***************************************************************************************
 * @file     Vectors.s
 * @version  V1.0
 * @date     18. July 2016
 *
 * @note
 * VORAGO Technologies 
 *
 * @note
 * Copyright (c) 2013-2016 VORAGO Technologies. 
 *
 * @par
 * BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND BY 
 * ALL THE TERMS AND CONDITIONS OF THE VORAGO TECHNOLOGIES END USER LICENSE AGREEMENT. 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. VORAGO TECHNOLOGIES 
 * SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL 
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 ****************************************************************************************/
  .syntax unified
  .cpu cortex-m0
  .fpu softvfp
  .thumb
  .global g_pfnVectors
 
  .word __DATA_START  /* Start address for data section */ 
  .word __DATA_END    /* End address for data section */ 
  .word __START_BSS   /* Start address for .bss section */
  .word __END_BSS     /* End address for .bss section */
  .word __STACK_BASE  /* Stack base */ 

  .weakref NMI_Handler, Default_Exception_Handler 
  .weakref HardFault_Handler, Default_Exception_Handler 
  .weakref MemManage_Handler, Default_Exception_Handler
  .weakref BusFault_Handler, Default_Exception_Handler 
  .weakref UsageFault_Handler, Default_Exception_Handler 
  .weakref SVC_Handler, Default_Exception_Handler 
  .weakref DebugMon_Handler, Default_Exception_Handler 
  .weakref PendSV_Handler, Default_Exception_Handler 
  .weakref SysTick_Handler, Default_Exception_Handler
  .weakref OC2_IRQHandler, Default_Exception_Handler
  .weakref VOR_GPIO_IRQHandler, Default_Exception_Handler 
  .weakref OC13_IRQHandler, Default_Exception_Handler  
  .weakref OC14_IRQHandler, Default_Exception_Handler  
  .weakref OC15_IRQHandler, Default_Exception_Handler  
  .weakref OC16_IRQHandler, Default_Exception_Handler  
  .weakref OC17_IRQHandler, Default_Exception_Handler  
  .weakref OC18_IRQHandler, Default_Exception_Handler  
  .weakref OC19_IRQHandler, Default_Exception_Handler  
  .weakref OC20_IRQHandler, Default_Exception_Handler  
  .weakref OC21_IRQHandler, Default_Exception_Handler  
  .weakref OC22_IRQHandler, Default_Exception_Handler
  .weakref OC23_IRQHandler, Default_Exception_Handler  
  .weakref OC24_IRQHandler, Default_Exception_Handler  
  .weakref OC25_IRQHandler, Default_Exception_Handler  
  .weakref OC26_IRQHandler, Default_Exception_Handler  
  .weakref OC27_IRQHandler, Default_Exception_Handler  
  .weakref OC28_IRQHandler, Default_Exception_Handler  
  .weakref OC29_IRQHandler, Default_Exception_Handler  
  .weakref OC30_IRQHandler, Default_Exception_Handler  
  .weakref OC31_IRQHandler, Default_Exception_Handler

  .section ".text.vectors"
  .weak __interrupt_vector_table
  .type __interrupt_vector_table, %object
__interrupt_vector_table: 
  .long __STACK_BASE
  .long Reset_Handler             /* Reset Handler */ 
  .long NMI_Handler               /* NMI Handler */ 
  .long HardFault_Handler         /* Hard Fault Handler */ 
  .long MemManage_Handler         /* MPU Fault Handler */
  .long BusFault_Handler          /* Bus Fault Handler */ 
  .long UsageFault_Handler        /* Usage Fault Handler */ 
  .long 0                         /* Reserved */ 
  .long 0                         /* Reserved */ 
  .long 0                         /* Reserved */ 
  .long 0                         /* Reserved */ 
  .long SVC_Handler               /* SVCall Handler */ 
  .long DebugMon_Handler          /* Debug Monitor Handler */ 
  .long 0                         /* Reserved */ 
  .long PendSV_Handler            /* PendSV Handler */ 
  .long SysTick_Handler           /* SysTick Handler */ 

  /* External Interrupts */ 
  .long OC0_IRQHandler   	        /* 0: TIM 0 ISR */ 
  .long VOR_TIM1_IRQHandler 	    /* 1: TIM 1 ISR */ 
  .long OC2_IRQHandler            /* 2: General */ 
  .long VOR_UART0_IRQHandler      /* 3: UART A ISR */ 
  .long VOR_UART1_IRQHandler      /* 4: UART B ISR */ 
  .long VOR_GPIO_IRQHandler   	  /* 5: GPIO ISR */ 
  .long VOR_SPI0_IRQHandler       /* 6: SPI A ISR */ 
  .long VOR_SPI1_IRQHandler       /* 7: SPI B ISR */ 
  .long VOR_SPI2_IRQHandler       /* 8: SPI C ISR */ 
  .long VOR_I2C0_MS_IRQHandler    /* 9: I2C A Master ISR */ 
  .long VOR_I2C0_SL_IRQHandler    /* 10: I2C A Slave ISR */ 
  .long VOR_I2C1_MS_IRQHandler    /* 11: I2C B Master ISR */ 
  .long VOR_I2C1_SL_IRQHandler    /* 12: I2C B Slave ISR */ 
  .long OC13_IRQHandler           /* 13: General */ 
  .long OC14_IRQHandler           /* 14: General */ 
  .long OC15_IRQHandler           /* 15: General */ 
  .long OC16_IRQHandler           /* 16: General */ 
  .long OC17_IRQHandler           /* 17: General */ 
  .long OC18_IRQHandler           /* 18: General */ 
  .long OC19_IRQHandler           /* 19: General */ 
  .long OC20_IRQHandler           /* 20: General */ 
  .long OC21_IRQHandler           /* 21: General */ 
  .long OC22_IRQHandler           /* 22: General */ 
  .long OC23_IRQHandler           /* 23: General */ 
  .long OC24_IRQHandler           /* 24: General */ 
  .long OC25_IRQHandler           /* 25: General */ 
  .long OC26_IRQHandler           /* 26: General */ 
  .long OC27_IRQHandler           /* 27: General */ 
  .long OC28_IRQHandler           /* 28: General */ 
  .long OC29_IRQHandler           /* 29: General */ 
  .long OC30_IRQHandler           /* 30: General */ 
  .long OC31_IRQHandler           /* 31: General */ 

  .size __interrupt_vector_table, .-__interrupt_vector_table

 